unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls;

type
  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    ComboBox1: TComboBox;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    Label1: TLabel;
    Label2: TLabel;
    Image1: TImage;
    Image2: TImage;
    Image3: TImage;
    Image4: TImage;
    procedure FormCreate(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  CommName: PChar;
  hCommDev: THANDLE;
  strSetPin: String;
  strClrPin: String;


implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
     strSetPin:='MARK (-10V)';
     strClrPin:='SPACE (+10V)';
     Form1.Left:=300;
     Form1.Top:=200;
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
     if ComboBox1.Text='COM1' then
     begin
          CommName:='COM1';
     end;

     if ComboBox1.Text='COM2' then
     begin
          CommName:='COM2';
     end;

     if (ComboBox1.Text<>'COM1') and (ComboBox1.Text<>'COM2') then
     begin
          Application.MessageBox('Select correct COM name!','Invalid COM name',0);
     end
     else
     begin
          hCommDev:= CreateFile(CommName, GENERIC_READ or
                        GENERIC_WRITE,0, NIL,
                        OPEN_EXISTING, 0, 0);

          if hCommDev = INVALID_HANDLE_VALUE then
          begin
               Application.MessageBox('Unable to open port!','Error opening port',0);
          end
          else
          begin
               SpeedButton2.Enabled:=true;
               SpeedButton1.Enabled:=false;
               CheckBox1.Enabled:=true;
               CheckBox2.Enabled:=true;
               EscapeCommFunction(hCommDev,SETDTR);
               EscapeCommFunction(hCommDev,SETRTS);
               Image1.Picture.Bitmap:=Image4.Picture.Bitmap;
               Image2.Picture.Bitmap:=Image4.Picture.Bitmap;
               Label1.Caption:=strClrPin;
               Label2.Caption:=strClrPin;
               Label1.Enabled:=true;
               Label2.Enabled:=true;
          end;
     end;
end;

procedure TForm1.SpeedButton2Click(Sender: TObject);
begin
     CheckBox1.Checked:=false;
     CheckBox2.Checked:=false;
     SpeedButton1.Enabled:=true;
     SpeedButton2.Enabled:=false;
     CheckBox1.Enabled:=false;
     CheckBox2.Enabled:=false;
     Label1.Enabled:=false;
     Label2.Enabled:=false;
     Image1.Picture:=nil;
     Image2.Picture:=nil;
     Label1.Caption:='';
     Label2.Caption:='';

     CloseHandle(hCommDev);
end;
procedure TForm1.CheckBox1Click(Sender: TObject);
begin
     if CheckBox1.Checked=true then
     begin
          if EscapeCommFunction(hCommDev,CLRRTS) <> false then
          begin;
                Label1.Caption:=strSetPin;
                Image1.Picture.Bitmap:=Image3.Picture.Bitmap;
          end
          else
          begin
               Application.MessageBox('Unable to communicate with COM!','Error',0);
          end;
     end
     else
     begin
          if EscapeCommFunction(hCommDev,SETRTS) <> false then
          begin;
                Label1.Caption:=strClrPin;
                Image1.Picture.Bitmap:=Image4.Picture.Bitmap;
          end
          else
          begin
               Application.MessageBox('Unable to communicate with COM!','Error',0);
          end;
     end;
end;

procedure TForm1.CheckBox2Click(Sender: TObject);
begin
     if CheckBox2.Checked=true then
     begin
          if EscapeCommFunction(hCommDev,CLRDTR) <> false then
          begin;
                Label2.Caption:=strSetPin;
                Image2.Picture.Bitmap:=Image3.Picture.Bitmap;
          end
          else
          begin
               Application.MessageBox('Unable to communicate with COM!','Error',0);
          end;
     end
     else
     begin
          if EscapeCommFunction(hCommDev,SETDTR) <> false then
          begin;
                Label2.Caption:=strClrPin;
                Image2.Picture.Bitmap:=Image4.Picture.Bitmap;
          end
          else
          begin
               Application.MessageBox('Unable to communicate with COM!','Error',0);
          end;
     end;
end;

end.
